/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <DxcConfig.hpp>
#include <Connection/DAConnector.hpp>

using namespace Dxc;

DAConnector::DAConnector(DxcCallback *cb) : DxcConnectorImp(cb),
    sdsock_(-1),
    srsock_(-1)
{
    initConnections();
}

void DAConnector::initConnections()
{
    connect("localhost", DxcConfig::getInstance()->getInt("SDS_DA_PORT"), &sdsock_);
    connect("localhost", DxcConfig::getInstance()->getInt("SR_DA_PORT"), &srsock_);
}

bool DAConnector::sendMessage(const DxcData *msg)
{
    bool rc = true;

    std::string msgType(typeid(*msg).name());
    if (msgType == typeid(CommandData).name())
    {
        if (sdsock_ > 0)
            rc &= DxcConnectorImp::transmit(sdsock_, msg);
    }

    if (srsock_ > 0)
    {
        rc &= DxcConnectorImp::transmit(srsock_, msg);
    }

    return rc;
}
