package org.dxc.evaluator.metrics;

/*
 * CPU Time metric.
 */
public class DetectionAccuracy implements DAMetricCalculator {
    private int totalScenarios = -1;
    private int correct = -1;
    private double acc = Double.NaN;
    private int minPoints = -1;

    public void addSMCalculator(ScenarioMetricCalculator smc) {
        Detection d = (Detection) smc;
        if (d == null)
            return;

        if (totalScenarios < 0
                && !d.getDetection().equals(Detection.DetectionType.UNDEFINED)) {
            totalScenarios = 1;
            correct = 0;
        } else {
            totalScenarios++;
        }

        if (d.getDetection().equals(Detection.DetectionType.TRUE_POSITIVE)
                || d.getDetection().equals(
                        Detection.DetectionType.TRUE_NEGATIVE)) {
            correct++;
        }
    }

    public void calculate() {
        if (totalScenarios == 0)
            acc = 0;
        else
            acc = correct / (double) totalScenarios;
    }

    public double getScore() {
        if (totalScenarios >= minPoints)
            return acc;
        else
            return Double.NaN;
    }

    public void setMinDataPoints(int min) {
        minPoints = min;
    }

    public void print() {
        System.out.println("Detection Accuracy: " + acc);
    }
}