package org.dxc.evaluator.metrics;

/*
 * CPU Time metric.
 */
public class MeanIsolationTime implements DAMetricCalculator {
    private double totalTime = Double.NaN;
    private int dataPoints = 0;
    private int minPoints = -1;

    public void addSMCalculator(ScenarioMetricCalculator smc) {
        IsolationTimeList l = (IsolationTimeList) smc;
        if (l == null)
            return;

        for (IsolationTime i : l) {
            double time = i.getScore();
            if (!((Double) time).isNaN()) {
                if (((Double) totalTime).isNaN())
                    totalTime = time;
                else
                    totalTime += time;

                dataPoints++;
            }
        }
    }

    public void calculate() {
    }

    public double getScore() {
        if (dataPoints >= minPoints)
            return totalTime / dataPoints;
        else
            return Double.NaN;
    }

    public void setMinDataPoints(int min) {
        minPoints = min;
    }

    public void print() {
        System.out.println("Isolation Time: " + getScore());
    }
}