package org.dxc.evaluator.metrics;

/*
 * Evaluator metric calculator.
 */
public class MetricCalculatorFactory {
    public static DAMetricCalculator getDAMetric(String name) {
        if (name.equals("falsePositivesRate"))
            return new FalsePositives();
        else if (name.equals("falseNegativesRate"))
            return new FalseNegatives();
        else if (name.equals("detectionAccuracy"))
            return new DetectionAccuracy();
        else if (name.equals("sum"))
            return new Sum();
        else if (name.equals("meanIsolationTime"))
            return new MeanIsolationTime();
        else
            return new Average();
    }

    public static ScenarioMetricCalculator getScenarioMetric(String name) {
        if (name.equals("CPUTime"))
            return new CPUTime();
        else if (name.equals("peakMemory"))
            return new PeakMemory();
        else if (name.equals("detection"))
            return new Detection();
        else if (name.equals("classificationErrors"))
            return new ClassificationErrors();
        else if (name.equals("isolationTimeList"))
            return new IsolationTimeList();
        else if (name.equals("utility"))
            return new Utility();
        else if (name.equals("recoveryCost"))
            return new RecoveryCost();
        else if (name.equals("probeCost"))
            return new ProbeCost();

        return null;
    }
}