package org.dxc.evaluator.metrics;

import java.util.Map;

import org.dxc.api.datatypes.*;

public class ProbeCost implements ScenarioMetricCalculator {
    private double score = Double.NaN;
    private Map<String, Double> costs = null;

    public ProbeCost() {
    }

    public void addData(DxcData d) {
        if (((Double) score).equals(Double.NaN))
            score = 0;

        if (d instanceof CommandData) {
            if (d.getSource() == null || !d.getSource().equals("SDS")) {
                CommandData cd = (CommandData) d;
                for (Command c : cd.getCommands()) {
                    if (c.getCommandID().equals("probe") && costs != null) {
                        score += costs.get(((StringValue) c.getValue()).get());
                    }
                }
            }
        } else if (d instanceof ScenarioData) {
            ScenarioData sd = (ScenarioData) d;
            try {
                SystemCatalog sc = SystemCatalogXML.getInstance(sd
                        .getSystemName());
                costs = sc.getSensorsAndCosts();
            } catch (Exception ex) {
                System.err.println(ex);
            }
        }
    }

    public void calculate() {
    }

    public double getScore() {
        return score;
    }

    public void print() {
        System.out.println("Probe Cost: " + score);
    }

}
