/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_PROCESS_FACTORY_H
#define DXC_PROCESS_FACTORY_H

#include <DAConfig.hpp>
#include <ProcessLoader.hpp>

namespace Dxc
{

class ProcessFactory
{
public:
    static ProcessLoader* createProcessLoader(const std::string& name, const std::string& directory, const std::string& args);
    static ProcessLoader* createDAProcessLoader(const DAConfig& daConf, const std::string& system);
};

}

#endif
